Declare @StartDate as date = '1975-01-01'
Declare @EndDate as date = '2025-12-31';

with DateRange (CurrentDate) as
(
	select @StartDate as CurrentDate
	union all
	select dateadd(DAY,1,CurrentDate)
	from DateRange where dateadd(Day,1,CurrentDate) < = @EndDate
)
select 
Year(CurrentDate) * 10000 + Month(CurrentDate) * 100 + Day(CurrentDate) as ID
,CurrentDate  as [Date]
,datename(year,CurrentDate) as [Year]
,'Q' + datename(Q, currentdate) as [Quarter]
,dateName(Month,CurrentDate) as [Month]
,'Week ' + datename(Week, CurrentDate) as [Week]
,datename(d,CurrentDate) as [Day of Month]
,datename(DW,CurrentDate) as [Weekday]
,datepart(Q, CurrentDate) as [Quarter of Year]
,datepart(M, CurrentDate) as [Month of Year]
,datepart(Week, CurrentDate) as [Week of Year]
,datepart(dy,CurrentDate) as [Day of Year]
,DATEPART(DW, CurrentDate) as [Day of Week]
from DateRange
order by CurrentDate
option (maxrecursion 0)
